<template>
  <section rowentry :class="entry.type" :edited="edited" :selected="selected">
    <div  v-if="isTextInput" splitter>
      <md-button class="md-icon-button" @click="copyToClipboard(entry.newValue)">
        <md-icon md-src="/img/md/file_copy.svg"/>
      </md-button>
      <md-field v-if="isTextInput">
        <label>{{entry.columnName}}</label>
        <md-input v-if="!entry.maxSize || entry.maxSize <= 256"
                  v-model="entry.newValue"
                  :maxlength="entry.maxSize"
                  :disabled="disabled"></md-input>
        <md-textarea v-else md-autogrow
                    v-model="entry.newValue"
                    :maxlength="entry.maxSize"
                    :disabled="disabled"></md-textarea>
      </md-field>
    </div>

    <md-field v-else-if="entry.type === 'date'">
      <label>DATE</label>
      <md-input :value="displayDate(entry.value)"
                disabled></md-input>
    </md-field>

    <md-menu version-menu md-align-trigger v-else-if="entry.type === 'version'">
      <span md-menu-trigger>v{{entry.value}} <md-icon md-src="/img/md/arrow_drop_down.svg"/></span>
      <md-menu-content>
        <p v-for="versionEntry in otherVersions" :key="versionEntry.version" @click="switchVersion(versionEntry)">{{versionEntry.version}}</p>
      </md-menu-content>
    </md-menu>

    <div v-else-if="entry.type === 'key'" splitter>
      <md-button class="md-icon-button" @click="copyToClipboard(entry.newValue)">
        <md-icon md-src="/img/md/file_copy.svg"/>
      </md-button>
      <md-field md-clearable @click="showMenu = !showMenu">
        <label><span>{{entry.columnName}}</span>
          <span v-if="invalidationReason"> - </span>
          <span v-if="invalidationReason === 'deprecated'" red>deprecated</span>
          <span v-if="invalidationReason === 'superseded'">new version available</span>
        </label>
        <md-menu md-direction="bottom-start" md-dense md-align-trigger md-full-width :md-active.sync="showMenu">
          <md-input v-model="entry.newValue"
                    @click.stop.prevent="startSearch"
                    @focus.stop="openMenu"
                    :disabled="disabled"/>
          <md-menu-content row-entry-menu>
            <template v-if="isPending(keyOptions)">
              <p>loading..</p>
            </template>
            <template v-else>
              <p @click.stop="">showing {{filterSearch(search, keyOptions).length}}/{{keyOptions.length}} options</p>
              <input ref="search" type="text" @click.stop="" v-model="search" placeholder="search">
              <md-menu-item v-for="option in filterSearch(search, keyOptions)" :key="option" @click="select(option)">{{option}}</md-menu-item>
            </template>
          </md-menu-content>
        </md-menu>
      </md-field>
      <md-button class="md-icon-button md-primary" @click="followEntry()">
        <md-icon md-src="/img/md/arrow_forward.svg"/>
      </md-button>
    </div>

    <div v-else-if="entry.type === 'clob'" splitter>
      <md-button class="md-icon-button md-primary" @click="downloadClob"><md-icon md-src="/img/md/save_alt.svg"/></md-button>
      <md-button class="md-icon-button md-primary" @click="uploadClob" :disabled="disabled"><md-icon md-src="/img/md/publish.svg"/></md-button>
      <md-field>
        <label>{{entry.columnName}}</label>
        <md-input :value="entry.newValue" disabled></md-input>
      </md-field>
      <md-button class="md-icon-button md-primary" @click="followEntry({fullscreen: true})"><md-icon md-src="/img/md/fullscreen.svg"/></md-button>
      <md-button class="md-icon-button md-primary" @click="followEntry()"><md-icon md-src="/img/md/arrow_forward.svg"/></md-button>
    </div>

    <p v-else>{{entry.columnName}} ({{entry.type}}) = {{entry.value}}</p>
  </section>
</template>

<script lang='ts'>
import { Component, Vue, Prop, Watch } from 'vue-property-decorator';
import { MdProgress } from 'vue-material/dist/components';
import isPromise from 'is-promise';
import { store } from '../../store';
import { KeyPathKey } from '../../store/editor';
import axios from '../../lib/axios';
import { download, upload } from '../../lib/clob';
import { CompiledRow } from './rowEditor.vue';
import * as dateFormatter from '../../lib/dateFormatter';
import copyToClipboard from '../../lib/copyToClipboard';
import { notify } from '../../components/app/alerting';

interface OtherVersion {version: string; key: string; }
type KeyOptions = Promise<string[] | null> | string[];

Vue.use(MdProgress);
@Component({
  components: {
  },
})
export default class extends Vue {

  get isTextInput(): boolean {
    if (!this.entry) {
      return false;
    }
    const types: Array<CompiledRow['type']> = ['readonly', 'text'];
    return types.includes(this.entry.type);
  }

  get selected(): boolean {
    if (!this.entry) {
      return false;
    } else if (this.entry.type === 'clob') {
      const myKeyPath = store.state.editor.keyPath[this.pathIndex];
      if (!myKeyPath.options.clob) {
        return false;
      }
      return myKeyPath.options.clob === this.entry.columnName;
    } else if (this.entry.type === 'key') {
      const nextEntry = store.state.editor.keyPath[this.pathIndex + 1];
      if (!nextEntry) {
        return false;
      }
      return this.entry.referencedTable === nextEntry.tableName && this.entry.newValue === nextEntry.key;
    } else {
      return false;
    }
  }

  get disabled(): boolean {
    if (!this.entry) {
      return true;
    }
    if (store.get.auth('isReadMode')) {
      return true;
    }
    const types: Array<CompiledRow['type']> = [
      'readonly', 'date',
    ];
    return types.includes(this.entry.type);
  }

  get isReadMode() {
    return store.get.auth('isReadMode');
  }

  get edited() {
    return this.entry && this.entry.newValue !== this.entry.value;
  }

  get invalidationReason(): string {
    if (!this.entry.value || !this.fkData.metaData) {
      return '';
    }
    const pkeyName: string = this.fkData.metaData.find(c => c.constraints.includes('primary')).name ||
          this.fkData.metaData[0].name;
    const currentKey = this.fkData.rows.find( key => key[pkeyName] === this.entry.value );
    if (!currentKey) {
      return '';
    }

    let superseded = currentKey ? currentKey.VALID === 'N' : false;
    let deprecated = currentKey ? currentKey.MODE_VALID === 'N' : false;

    // special case for CMS_RUN_MODES
    if ( currentKey && !currentKey.MODE_VALID && currentKey.VALID ) {
      deprecated = currentKey.VALID === 'N';
      superseded = false;
    }

    // special case for L1_MENU: both mode and valid columns
    const hasMode = !!currentKey.MODE;
    if (this.keyData.validation === 'manual' && hasMode) {
      const mode = currentKey.MODE.toLowerCase();
      const version = Number(currentKey.VERSION);
      superseded = this.fkData.rows
        .filter( key => mode === key.MODE.toLowerCase() && Number(key.VERSION) > version).length > 0;
    }

    return deprecated ? 'deprecated' : superseded ? 'superseded' : '';
  }

  private showMenu = false;
  private search = '';

  private keyOptions: KeyOptions = Promise.resolve(null);

  @Prop()
  private entry!: CompiledRow;

  @Prop()
  private pathIndex!: number;

  @Prop()
  private keyData!: any;

  private fkData: any = {};

  private otherVersions: OtherVersion[] = [];

  public async mounted() {
    const e = this.entry;
    if (!e) {
      return;
    } else if (e.type === 'key') {
      this.keyOptions = store.dispatch.database('getValidKeys', [e.referencedTable, this.entry.value])
      .then(({data}) => {
        this.fkData = data;
        const pkeyName: string = data.metaData.find(c => c.constraints.includes('primary')).name ||
          data.metaData[0].name;
        return data.rows.map(r => r[pkeyName]);
      });
    } else if (e.type === 'version') {
      const { data } = await store.dispatch.database('getKeys', [e.table]);
      this.otherVersions = data.rows
      .filter(row => row.MODE === e.mode)
      .sort((a, b) => {
        const aa = a.VERSION + '';
        const bb = b.VERSION + '';
        if (aa.length > bb.length) {
          return -1;
        } else if (aa.length < bb.length) {
          return 1;
        } else if (aa > bb) {
          return -1;
        } else {
          return 1;
        }
      })
      .map(row => ({
        version: 'v' + row.VERSION,
        key: row.ID,
      }));
    }
  }
  private startSearch() {
    this.openMenu();
    const s = this.$refs.search as HTMLElement;
    if (s) {
      s.focus();
    }
  }

  private openMenu() {
    this.showMenu = true;
  }

  private select(option: string) {
    this.entry.newValue = option;
    this.showMenu = false;
  }

  private filterSearch(search: string, keyOptions: KeyOptions): string[] {
    if (isPromise(keyOptions)) {
      return [];
    } else {
      return (keyOptions as string[]).filter(o => o.toLowerCase().indexOf(search.toLowerCase()) !== -1).slice(0, 50);
    }
  }

  private isPending(keyOptions) {
    return isPromise(keyOptions);
  }

  @Watch('keyOptions')
  private keyOptionsChanged(keyOptions) {
    if (isPromise(keyOptions)) {
      keyOptions.then(k => {
        if (k) {
          this.keyOptions = k as string[];
        }
      });
    }
  }

  @Watch('isReadMode')
  private readModeChanged(isReadMode, wasReadMode) {
    if (isReadMode) {
      this.entry.newValue = this.entry.value;
    }
  }

  private switchVersion(versionEntry: OtherVersion) {
    store.commit.editor('changeKeyPath', {entry: {options: {}, key: versionEntry.key}});
  }

  private displayDate(value: string) {
    return dateFormatter.formatForView(value);
  }

  private copyToClipboard(text: string) {
    return copyToClipboard(text);
  }

  private followEntry(options = {}) {
    if (!this.entry) {
      return;
    } else {
      console.log('following', {entry: this.entry, options});
      this.$emit('follow', this.entry, options);
    }
  }

  private downloadClob() {
    if (!this.entry || !this.entry.table || !this.entry.key || !this.entry.columnName) {
      return;
    }
    download(this.entry);
  }

  private uploadClob() {
    upload().then(newContent => {
      if (newContent) {
        this.entry.newValue = newContent;
      }
    });
  }
}
</script>

<style scoped lang='scss'>
[rowentry] {
  flex: 1;
  white-space: nowrap;
  margin: 0 10px;
  &.version {
    flex: 0;
  }
  .md-button {
    margin: 0;
  }
  .md-menu {
    width: 100%;
    display: flex;
  }
  [splitter] {
    display: flex;
    flex-direction: row;
    align-items: center;
  }
}
</style>
<style lang='scss'>
@import "../../style/variables/colors.scss";

[rowentry] {
  .md-icon.md-icon.md-icon {
    @include md-theme-component() {
      @include md-theme-property(color, accent);
      svg {
        @include md-theme-property(fill, accent);
      }
    }
  }

  &.key {
    .md-disabled.md-disabled.md-disabled {
      input {
        color: rgba(0, 0, 0, 0.7);
      }
    }
  }

  &.clob {
    input {
      text-overflow: ellipsis;
    }
  }

  &[edited] {
    background: md-get-palette-color(orange, 200);
  }

  &[selected] {
    background: rgba( $accent-color, .15 )
  }

  [red] {
    color: red;
  }
}
[version-menu] {
  [md-menu-trigger] {
    display: flex;
    flex-direction: row;
  }
  .md-menu-content {
    min-width: 0;
    p {
      margin: .5em 1em;
    }
  }
}
[row-entry-menu] {
  p {
    font-size: .8em;
    margin: .5em 1em;
    color: rgb(90, 90, 90);
  }
  input {
    border: 0;
    margin: 0;
    padding: 1em;
    background: rgb(247, 247, 247);
    color: rgb(90, 90, 90);
  }
}
</style>
